function [pchi,p] = chibar(c,w,cone)
%        [pchi,p] = chibar(c,w,cone)
%  -  calcola P(CHIBAR(w,k)>c) per T01
%  -  porre cone=-1 per T12
%  -  dichiarare 'global gdl'
%  -  per uso con finv, dichiarare 
%  -  'global w cone gdl'

if nargin == 1,      % -> per uso con finv
  global w cone gdl;
else, 
  global gdl;
end
% - dispone su vettore riga
[i,h]=size(w);  
if h == 1,
   W=w'; h=i; else W=w; 
end 
    
% - rovescia i pesi per T12
if cone == -1,
   W=W(h+1-(1:h));
end      
  p=zeros(h,1);
for i=1:h,
  if W(i) > 0,
    gdl=i-1; 
    if (gdl == 0),
      q0(i)=0; 
    elseif (gdl > 0) & (c < 10^(-10)),   
      p(i)=1;
    elseif (gdl == 1) & (c >= 10^(-10)),
      p(i)=quadl('chi',c,25);   
    elseif (gdl > 1) & (c >= 10 ^(-10)),
      p(i)=1-quadl('chi',0,c);         
    end
  end
end

% - p-value
    pchi=W*p; 
