function [s,ym,m] = discrete(y,cp)
%%       [s,yn,m] = discrete(y,cp)
% given colvec of obs y(n) and rowvec of cut point cp(k),
% sets s=i if cp(i-1) < y <= cp(i), ym(n)=mean(Y | s)
% m(k+1) is vector of conditional means

m=size(y,1); k=size(cp,2);
s=sum((y*ones(1,k))>(ones(m,1)*cp),2);
n=tabel(s); m=zeros(k+1,1);
for i=1:k+1,
    m(i)=mean(y(s==(i-1)));
end
ym=m(s+1);
